program vhd2img;

{$APPTYPE CONSOLE}

uses
  windows,SysUtils;

type TCHS=packed record
c:word;
h:byte;
s:byte;
end;  

//vhd
type TVhd_Fixed=packed record
Cookie:array[0..7] of char;
Features:dword;
Format:dword;
Data_Offset:int64;
Time_Stamp:dword;
Creator_Application:array[0..3] of char;
Creator_Version:dword;
Creator_Host_OS:array[0..3] of char;
Original_Size:int64;
Current_Size:int64;
Disk_Geometry:TCHS;
Disk_Type:dword;
Checksum:dword;
UniqueId:TGUID;
//UniqueId:array[0..15] of byte;
Saved_State:byte;
Reserved:array[0..426] of byte;
end;
PVhd_Fixed=^TVhd_Fixed;

type TVhd_Dyn=packed record  //1024 bytes
Cookie:array[0..7] of char;
Data_Offset:int64;
Table_Offset:int64;
Header_Version:dword;
max_entries:dword;
block_size:dword;
Checksum:dword;
Parent_Unique_ID:tguid;
Parent_Time_Stamp:dword;
Reserved_1:dword;
Parent_Unicode_Name:array[0..511] of byte;
Parent_Locator_Entry_1:array[0..23] of byte;
Parent_Locator_Entry_2:array[0..23] of byte;
Parent_Locator_Entry_3:array[0..23] of byte;
Parent_Locator_Entry_4:array[0..23] of byte;
Parent_Locator_Entry_5:array[0..23] of byte;
Parent_Locator_Entry_6:array[0..23] of byte;
Parent_Locator_Entry_7:array[0..23] of byte;
Parent_Locator_Entry_8:array[0..23] of byte;
Reserved_2:array[0..255] of byte;
end;
PVhd_dyn=^TVhd_dyn;

type TPARTITION =packed record
      bootIndicator:BYTE;    //1
      head_start:byte;       //1
      cyl_sect_start:word;   //2
      systemId:BYTE;         //1
      head_end:byte;         //1
      cyl_sect_end:word;     //2
      relativeSectors:DWORD; //4
      totalSectors:DWORD;    //4
end;



const INVALID_SET_FILE_POINTER = DWORD(-1);

var
CancelFlag:boolean;
//

function _checksum3(buf:pointer; length:ulong):ulong;
var
  //p:pdword;
  p:puchar;
  sum: ulong;
begin
  //p:=@buf;
  p:=puchar(buf);
  sum:=0;
  while (Length <> 0) do
    begin
        sum := sum + uchar(p^);
        dec(length);
        inc(p);
    end;
	Sum := not Sum; //operator bitwise ~
  //sum := sum xor $FFFFFFFF;
  result:=sum;
end;

function Swap16(ASmallInt : SmallInt) : SmallInt ; register ;
 asm  xchg al,ah  end ;

function Swap32(value : dword) : dword ; assembler ;
  asm  bswap eax  end ;

function Int64Swap(A : int64) : int64 ;
  asm  mov edx,dword ptr [A] ; mov eax,dword ptr [A+4]
  bswap edx ; bswap eax  end ;

function DecToBinStr(N: Integer): string;
var
  S: string;
  i: Integer;
  Negative: Boolean;
begin
  if N<0 then Negative:=True;
  N:=Abs(N);
  for i:=1 to SizeOf(N)*8 do
  begin
    if N<0 then S:=S+'1'
    else S:=S+'0';
    N:=N shl 1;
  end;
  Delete(S,1,Pos('1',S)-1);
  //if Negative then S:='-'+S;
  Result:=S;
end;  

function _Get_FileSize2(const FileName: string): TULargeInteger;
// by nico
var
  Find: THandle;
  Data: TWin32FindData;
begin
  Result.QuadPart := -1;
  Find := FindFirstFile(PChar(FileName), Data);
  if (Find <> INVALID_HANDLE_VALUE) then
  begin
    Result.LowPart  := Data.nFileSizeLow;
    Result.HighPart := Data.nFileSizeHigh;
    Windows.FindClose(Find);
  end;
end;

procedure info(file_in:string);
var
hDevice_src:thandle;
size:TULargeInteger;
buf:array[0..511] of byte;
bytesread:cardinal;
Current_Size,Original_Size,Data_Offset,table_offset:int64;
ipos:int64;
max_entries,block_offset,cnt,first_block_offset:dword;
begin
Current_Size:=0;Original_Size:=0;Data_Offset:=0;
size:=_Get_FileSize2(file_in);
writeln('filesize='+inttostr(size.QuadPart ));
if size.QuadPart mod 512<>0 then
  begin
  writeln('mod 512 <>0');
  exit;
  end;
hDevice_src := CreateFile(pchar(file_in ), GENERIC_READ, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
//footer
ipos:=size.QuadPart -512;
SetFilePointer(hdevice_src, int64rec(ipos).Lo , @int64rec(ipos).hi, FILE_BEGIN);
fillchar(buf,512,0);
ReadFile (hDevice_Src, buf[0], 512, bytesread, nil);
if (pVhd_Fixed(@buf[0])^.cookie ='conectix') and (swap32(pVhd_Fixed(@buf[0])^.Disk_Type)=2) then
  begin
  Original_Size:=Int64Swap(pVhd_Fixed(@buf[0])^.Original_Size);
  Current_Size:=Int64Swap(pVhd_Fixed(@buf[0])^.Current_Size );
  writeln('Infos found in header - fixed');
  writeln('features='+inttostr(swap32(pVhd_Fixed(@buf[0])^.features)));
  writeln('Format=$'+inttohex(swap32(pVhd_Fixed(@buf[0])^.Format),4));
  writeln('Data_offset='+inttostr(int64swap(pVhd_Fixed(@buf[0])^.Data_offset)));
  writeln('Creator_Application='+pVhd_Fixed(@buf[0])^.Creator_Application);
  writeln('Creator_Version=$'+inttohex(swap32(pVhd_Fixed(@buf[0])^.Creator_Version),4));
  writeln('Creator_Host_OS='+pVhd_Fixed(@buf[0])^.Creator_Host_OS);
  writeln('Original_Size='+inttostr(Original_Size));
  writeln('Current_Size='+inttostr(Current_Size));
  writeln('Checksum=$'+inttohex(pVhd_Fixed(@buf[0])^.Checksum,4));
  writeln('saved_state='+inttostr(pVhd_Fixed(@buf[0])^.saved_state));
  end;
if (pVhd_Fixed(@buf[0])^.cookie ='conectix') and (swap32(pVhd_Fixed(@buf[0])^.Disk_Type)=3) then
  begin
  Original_Size:=Int64Swap(pVhd_Fixed(@buf[0])^.Original_Size);
  Current_Size:=Int64Swap(pVhd_Fixed(@buf[0])^.Current_Size );
  writeln('Infos found in header - dynamic');
  writeln('features='+inttostr(swap32(pVhd_Fixed(@buf[0])^.features)));
  writeln('Format=$'+inttohex(swap32(pVhd_Fixed(@buf[0])^.Format),4));
  writeln('Data_offset='+inttostr(int64swap(pVhd_Fixed(@buf[0])^.Data_offset)));
  writeln('Creator_Application='+pVhd_Fixed(@buf[0])^.Creator_Application);
  writeln('Creator_Version=$'+inttohex(swap32(pVhd_Fixed(@buf[0])^.Creator_Version),4));
  writeln('Creator_Host_OS='+pVhd_Fixed(@buf[0])^.Creator_Host_OS);
  writeln('Original_Size='+inttostr(Original_Size));
  writeln('Current_Size='+inttostr(Current_Size));
  writeln('Checksum=$'+inttohex(pVhd_Fixed(@buf[0])^.Checksum,4));
  writeln('saved_state='+inttostr(pVhd_Fixed(@buf[0])^.saved_state));
  //
  writeln('');
  ipos:=512;
  SetFilePointer(hdevice_src, int64rec(ipos).Lo , @int64rec(ipos).hi, FILE_BEGIN);
  fillchar(buf,512,0);
  ReadFile (hDevice_Src, buf[0], 512, bytesread, nil);
  //writeln('Data_offset='+inttostr(int64swap(PVhd_dyn(@buf[0])^.Data_offset)));
  table_offset:=int64swap(PVhd_dyn(@buf[0])^.Table_Offset);
  writeln('Table_Offset='+inttostr(table_offset));
  writeln('Header_Version=$'+inttohex(swap32(PVhd_dyn(@buf[0])^.Header_Version),4));
  max_entries:=swap32(PVhd_dyn(@buf[0])^.max_entries);
  writeln('max_entries='+inttostr(max_entries)+' -> '+inttostr(max_entries*2048*1024)+' bytes');
  writeln('block_size='+inttostr(swap32(PVhd_dyn(@buf[0])^.block_size)));
  writeln('Checksum=$'+inttohex(PVhd_dyn(@buf[0])^.Checksum,4));
  writeln('');
  writeln('BAT size='+inttostr(max_entries*4));
  if (table_offset+max_entries*4) mod 512<>0
    then first_block_offset:=(1+(table_offset+max_entries*4) div 512)*512
    else first_block_offset:=table_offset+max_entries*4;
  writeln('1st block offset='+inttostr(first_block_offset));
  //
  //block_offset = sector offset (have to be multiplied by 512)
  {
  SetFilePointer (hDevice_src, int64swap(PVhd_dyn(@buf[0])^.Table_Offset), nil, FILE_BEGIN );
  for cnt:=0 to swap32(PVhd_dyn(@buf[0])^.max_entries)-1 do
    begin
    ReadFile (hDevice_Src, block_offset, 4, bytesread, nil);
    if block_offset<>$ffffffff then writeln('offset='+inttostr(swap32(block_offset)*512));
    //list.Add(inttostr(cnt)+'='+inttohex(swap32(block_offset)*512,4));
    end;
  }
  //
end;

if (Original_Size =0) and (Current_Size =0) then writeln('not a valid vhd');  
closehandle(hDevice_src );
end;

procedure make_footer(var vhd:TVhd_Fixed;size_,data_offset:int64;disk_type:dword);
var
total_size,total_sectors:int64;
vhd_c:word;
vhd_h,vhd_s:byte;
guid:tguid;
begin
if data_offset=0 then data_offset:=$FFFFFFFFFFFFFFFF;
total_size :=size_ ;
total_sectors:=total_size div 512;

  fillchar(vhd,sizeof(TVhd_Fixed),0);

  vhd_s:=63;
  vhd_h:=16;
  if (Total_Sectors >= (65535 * 16 * 63)) then vhd_h:= 64;vhd_s:=32;
  if (Total_Sectors >= (65535 * 64 * 32)) then vhd_h:= 128;vhd_s:=63;
  if (Total_Sectors >= (65535 * 128 * 63)) then vhd_h:= 255;vhd_s:=63;
  vhd_c:=(total_sectors div vhd_h div vhd_s)+1;

  vhd.Cookie :='conectix'; //8
  vhd.Features :=swap32($00000002); //4
  vhd.Format :=  swap32($00010000); //4
  vhd.Data_Offset :=int64swap(data_offset);
  vhd.Time_Stamp :=0; //swap32($11f76016);
  vhd.Creator_Application :='hack';
  vhd.Creator_Version:=swap32($00010000);
  vhd.Creator_Host_OS :='Wi2k';
  vhd.Original_Size :=Int64Swap(total_size); //8
  vhd.Current_Size :=Int64Swap(total_size); //8
  vhd.Disk_Geometry.c :=swap16(vhd_c); //2
  vhd.Disk_Geometry.h :=vhd_h; //1
  vhd.Disk_Geometry.s :=vhd_s; //1
  vhd.Disk_Type :=swap32(disk_type); //4
  CreateGUID(guid);  //{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
  //guid:=StringToGUID('82154420-0FBF-11d4-8313-005004526AB4');
  vhd.UniqueId := guid;
  vhd.Saved_State :=0;
  vhd.Checksum :=swap32(_checksum3(@vhd,sizeof(TVhd_Fixed)));
end;

procedure resize(file_in:string;new_size:int64);
var
hDevice_src,hDevice_dst:thandle;
old_filesize:TULargeInteger;
buf,bitmap,empty:array[0..511] of byte;
dyn:array[0..1023] of byte;
bytesread,byteswritten:cardinal;
ipos_src,ipos_dst,data_offset,table_offset,current_size:int64;
file_out:string;
old_max_entries,new_max_entries,
old_first_block_offset,new_first_block_offset,first_block_offset_diff,block_offset,
new_bat_size,
cnt,block_cnt:dword;
p:pointer;
begin
old_filesize:=_Get_FileSize2(file_in);
writeln('filesize='+inttostr(old_filesize.QuadPart ));
if old_filesize.QuadPart mod 512<>0 then
  begin
  writeln('mod 512 <>0');
  exit;
  end;
//
if new_size mod 512<>0 then
  begin
  writeln('mod 512 <>0');
  exit;
  end;
//  
  hDevice_src := CreateFile(pchar(file_in ), GENERIC_READ or generic_write, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);

//footer
  ipos_src:=old_filesize.QuadPart -512;
  SetFilePointer(hdevice_src, int64rec(ipos_src).Lo , @int64rec(ipos_src).hi, FILE_BEGIN);
  fillchar(buf,512,0);
  readfile(hDevice_Src, buf[0], 512, bytesread, nil);

  current_size:=int64swap(pVhd_Fixed(@buf[0])^.Current_Size) ;
  
//fixed vhd
if (pVhd_Fixed(@buf[0])^.cookie ='conectix') and (swap32(pVhd_Fixed(@buf[0])^.Disk_Type)=2) then
  begin
  //empty previous footer
  ipos_src:=old_filesize.QuadPart -512;
  SetFilePointer(hdevice_src, int64rec(ipos_src).Lo , @int64rec(ipos_src).hi, FILE_BEGIN);
  fillchar(empty,512,0);
  writefile(hDevice_Src, empty[0], 512, byteswritten, nil);
  //make new footer
  make_footer(pVhd_Fixed(@buf[0])^,new_size,0,2);
  //resize & write footer
  if setfilepointer(hDevice_src ,int64rec(new_size).Lo ,@int64rec(new_size).hi,file_begin)<>INVALID_SET_FILE_POINTER
    then
    begin
    writefile(hDevice_src ,buf[0],512,byteswritten,nil);
    if byteswritten<>sizeof(TVhd_Fixed) then writeln('WriteFile failed');
    end
    else writeln('INVALID_SET_FILE_POINTER');
  end; //if (pVhd_Fixed(@buf[0])^.cookie ='conectix') and (swap32(pVhd_Fixed(@buf[0])^.Disk_Type)=2) then

//dynamic vhd
if (pVhd_Fixed(@buf[0])^.cookie ='conectix') and (swap32(pVhd_Fixed(@buf[0])^.Disk_Type)=3) then
  begin
  if new_size mod 2048<>0 then
    begin
    writeln('mod 2048<>0');
    end
    else
    begin
    //lets create a new file
    file_out:=ExtractFilePath(file_in)+'new.vhd';
    {$i-}DeleteFile(file_out);{$i+}
    hDevice_dst := CreateFile(pchar(file_out), GENERIC_WRITE, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, CREATE_NEW, 0 , 0);
    //we need some numbers
    data_offset:=int64swap(pVhd_Fixed(@buf[0])^.data_offset);
    table_offset:=512+1024;
    new_max_entries:=new_size div (2048*1024);
    old_max_entries:=current_size div (2048*1024);
    //writeln('old max_entries='+inttostr(old_max_entries));
    //writeln('new max_entries='+inttostr(new_max_entries));
    //backup footer
    make_footer(pVhd_Fixed(@buf[0])^,new_size,data_offset,3);
    //ipos:=0;
    //SetFilePointer(hDevice_dst, int64rec(ipos).Lo , @int64rec(ipos).hi, FILE_BEGIN);
    writefile(hDevice_dst ,buf[0],512,byteswritten,nil);
    if byteswritten<>sizeof(TVhd_Fixed) then writeln('WriteFile failed');
    //we need to update the max entries in the second - dynamic header
    fillchar(dyn,1024,0);
    PVhd_dyn(@dyn[0])^.Cookie :='cxsparse';
    PVhd_dyn(@dyn[0])^.Data_Offset:=$ffffffffffffffff;
    PVhd_dyn(@dyn[0])^.Table_Offset :=int64swap(table_offset);
    PVhd_dyn(@dyn[0])^.Header_Version :=swap32($10000);
    PVhd_dyn(@dyn[0])^.max_entries :=swap32(new_max_entries);
    PVhd_dyn(@dyn[0])^.block_size  :=swap32($200000);
    PVhd_dyn(@dyn[0])^.Checksum :=swap32(_checksum3(@dyn[0],sizeof(TVhd_Dyn)));
    //ipos:=512;
    //SetFilePointer(hdevice_dst, int64rec(ipos).Lo , @int64rec(ipos).hi, FILE_BEGIN);
    writefile(hDevice_dst, dyn[0], sizeof(TVhd_Dyn), byteswritten , nil);
    if byteswritten<>sizeof(TVhd_Dyn) then writeln('WriteFile failed');
    //we need to rewrite the bat,  adding new blocks - example +200mb = +100 blocks * 4 bytes (offset) = +400bytes in the table
    //since the actual data will also moved a bit further in the file, we need to increment all offset
    //some calculations first...
    //writeln('Old BAT size='+inttostr(old_max_entries*4));
    if (table_offset+old_max_entries*4) mod 512<>0
      then old_first_block_offset:=(1+(table_offset+old_max_entries*4) div 512)*512
      else old_first_block_offset:=table_offset+old_max_entries*4;
    //writeln('Old 1st block offset='+inttostr(old_first_block_offset));
    //writeln('New BAT size='+inttostr(new_max_entries*4));
    if (table_offset+new_max_entries*4) mod 512<>0
      then new_first_block_offset:=(1+(table_offset+new_max_entries*4) div 512)*512
      else new_first_block_offset:=table_offset+new_max_entries*4;
    //writeln('new 1st block offset='+inttostr(new_first_block_offset));
    first_block_offset_diff:=new_first_block_offset-old_first_block_offset ;
    new_bat_size:=(new_max_entries*4)-(old_max_entries*4);
    //now lets really write the BAT
    ipos_src:=table_offset ; //skip headers
    ipos_dst:=table_offset;
    block_cnt:=0;
    SetFilePointer(hdevice_src, int64rec(ipos_src).Lo , @int64rec(ipos_src).hi, FILE_BEGIN);
    for cnt:=0 to old_max_entries-1 do
    begin
      ReadFile (hDevice_Src, block_offset, 4, bytesread, nil);
      if block_offset<>$ffffffff then
        begin
        block_offset:=swap32(block_offset)+(first_block_offset_diff div 512);
        block_offset :=swap32(block_offset);
        inc(block_cnt);
        end;
      writefile(hDevice_dst ,block_offset,4,byteswritten ,nil);
      if byteswritten<>4 then writeln('WriteFile failed');
      inc(ipos_dst,4);
    end;
    writeln('block_cnt='+inttostr(block_cnt ));
    //and the new unused blocks
    block_offset:=$ffffffff;
    for cnt:=old_max_entries to new_max_entries   do
    begin
      writefile(hDevice_dst,block_offset,4,byteswritten ,nil);
      if byteswritten<>4 then writeln('WriteFile failed');
      inc(ipos_dst,4);
    end;
    //and to finish with the BAT part, the padding to a sector boundary
    while ipos_dst mod 512 <>0 do
    begin
      writefile(hDevice_dst,block_offset,4,byteswritten ,nil);
      if byteswritten<>4 then writeln('WriteFile failed');
      inc(ipos_dst,4);
    end;
    //at this point ipos_dst = new_first_block_offset
    //we need to dump the actual data 2mb blocks
    ipos_src:=old_first_block_offset  ;
    SetFilePointer(hdevice_src, int64rec(ipos_src).Lo , @int64rec(ipos_src).hi, FILE_BEGIN);
    getmem(p,2097152); //or VirtualAlloc / virtuallock ?
    for cnt:=0 to block_cnt -1 do
    begin
      ReadFile (hDevice_Src, bitmap[0], 512, bytesread, nil);
      writefile(hDevice_dst ,bitmap[0],512,byteswritten ,nil);
      if byteswritten<>512 then writeln('WriteFile failed');
      ReadFile (hDevice_Src, p^, 2097152, bytesread, nil);
      writefile(hDevice_dst ,p^,2097152,byteswritten ,nil);
      if byteswritten<>2097152 then writeln('WriteFile failed');
    end;
    //header
    //ipos_dst:=old_filesize.QuadPart -512;
    //SetFilePointer(hdevice_dst, int64rec(ipos_dst).Lo , @int64rec(ipos_dst).hi, FILE_BEGIN);
    writefile(hDevice_dst ,buf[0],512,byteswritten,nil);
    if byteswritten<>sizeof(TVhd_Fixed) then writeln('WriteFile failed');
    //
    closehandle(hDevice_dst);

    end;
  end;
//
  closehandle(hDevice_src);
end;

procedure conv2fixvhd(file_in,file_out:string;new_size:int64=0);
var
hDevice_Src,hDevice_dst:thandle;
total_sectors,total_size:int64;
vhd:TVhd_Fixed ;
vhd_c:word;
vhd_h,vhd_s:byte;
guid:tguid;
byteswritten:cardinal;
ret:dword;
begin
CancelFlag:=false;
if file_in ='' then exit;
if new_size =0
  then total_size:=_Get_FileSize2(file_in).QuadPart
  else total_size :=new_size ;
total_sectors:=total_size div 512;

  fillchar(vhd,sizeof(TVhd_Fixed),0);

  vhd_s:=63;
  vhd_h:=16;
  if (Total_Sectors >= (65535 * 16 * 63)) then vhd_h:= 64;vhd_s:=32;
  if (Total_Sectors >= (65535 * 64 * 32)) then vhd_h:= 128;vhd_s:=63;
  if (Total_Sectors >= (65535 * 128 * 63)) then vhd_h:= 255;vhd_s:=63;
  vhd_c:=(total_sectors div vhd_h div vhd_s)+1;

  vhd.Cookie :='conectix'; //8
  vhd.Features :=swap32($00000002); //4
  vhd.Format :=  swap32($00010000); //4
  vhd.Data_Offset :=$FFFFFFFFFFFFFFFF;
  vhd.Time_Stamp :=0; //swap32($11f76016);
  vhd.Creator_Application :='hack';
  vhd.Creator_Version:=swap32($00010000);
  vhd.Creator_Host_OS :='Wi2k';
  vhd.Original_Size :=Int64Swap(total_size); //8
  vhd.Current_Size :=Int64Swap(total_size); //8
  vhd.Disk_Geometry.c :=swap16(vhd_c); //2
  vhd.Disk_Geometry.h :=vhd_h; //1
  vhd.Disk_Geometry.s :=vhd_s; //1
  vhd.Disk_Type :=swap32($00000002); //4
  CreateGUID(guid);  //{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
  vhd.UniqueId := guid;
  vhd.Saved_State :=0;
  vhd.Checksum :=swap32(_checksum3(@vhd,sizeof(TVhd_Fixed)));


  //if messageboxa(self.Handle ,pchar('append vhd footer to image file and rename it?'),'CloneDisk',mb_yesno)=id_no then exit;
  //append
  hDevice_src := CreateFile(pchar(file_in), generic_read or GENERIC_WRITE, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
  if hDevice_src=thandle(-1) then
  begin
  writeln('could not createfile');
  exit;
  end;
  if new_size =0
    then ret:=SetFilePointer(hdevice_src, 0, nil, FILE_END)
    else ret:=SetFilePointer(hdevice_src, int64rec(new_size).Lo, @int64rec(new_size).hi, FILE_BEGIN);
  if ret<>INVALID_SET_FILE_POINTER then
    begin
    //SetEndOfFile(hDevice_src);
    WriteFile (hDevice_src, vhd, sizeof(TVhd_Fixed), byteswritten, nil);
    if byteswritten<>sizeof(TVhd_Fixed) then writeln('WriteFile failed');
    closehandle(hDevice_src);
    hDevice_src:=thandle(-1);
    RenameFile(file_in ,file_out);
  end else writeln('SetFilePointer failed,'+SysErrorMessage(GetLastError));
  //
  if hDevice_src<>thandle(-1) then closehandle(hDevice_src);


end;

procedure conv2img(file_in,file_out:string);
var
buf,empty:array[0..511] of byte;
hDevice_src,hDevice_dst:thandle;
size:TULargeInteger;
bytesread,byteswritten:cardinal;
total_size,first,last,ipos,
table_offset,Data_Offset,Current_Size:int64;
i,j,cnt,block_size,max_entries,block_offset:dword;
ret,go:boolean;
kBufferSize,memsize:integer;
buffer:pointer;
bin:string;
mode:byte;
//list:tstrings;
offsets:array of dword;
begin
//showmessage(inttohex(swap32($0002302f),4));
//exit;
CancelFlag:=false;
{$i-}DeleteFile(file_out);{$i+}
size:=_Get_FileSize2(file_in);
first:=0;last:=size.quadpart;data_offset:=0;
//showmessage(inttostr(size.QuadPart ));
if size.QuadPart mod 512<>0 then
  begin
  writeln('mod 512 <>0');
  exit;
  end;
hDevice_src := CreateFile(pchar(file_in ), GENERIC_READ, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
//header  ?
SetFilePointer (hDevice_src, 0, nil, FILE_BEGIN );
fillchar(buf,512,0);
ReadFile (hDevice_Src, buf[0], 512, bytesread, nil);
if (pVhd_Fixed(@buf[0])^.cookie ='conectix') and (swap32(pVhd_Fixed(@buf[0])^.Disk_Type)=3) then
  begin
  //likely as dinamic disk have a 512bytes copy of the footer
  //right before the dynamic header
  data_offset:=Int64Swap(pVhd_Fixed(@buf[0])^.data_offset);
  Current_Size:=Int64Swap(pVhd_Fixed(@buf[0])^.Current_Size);
  go:=true;
  mode:=3;
  end;
//footer ?
ipos:=size.QuadPart -512;
SetFilePointer(hdevice_src, int64rec(ipos).Lo , @int64rec(ipos).hi, FILE_BEGIN);
fillchar(buf,512,0);
ReadFile (hDevice_Src, buf[0], 512, bytesread, nil);
if (pVhd_Fixed(@buf[0])^.cookie ='conectix') and (swap32(pVhd_Fixed(@buf[0])^.Disk_Type)=2) then
  begin
  last:=last-512;
  go:=true;
  mode:=2;
  end;
if (pVhd_Fixed(@buf[0])^.cookie ='conectix') and (swap32(pVhd_Fixed(@buf[0])^.Disk_Type)=3) then
  begin
  data_offset:=Int64Swap(pVhd_Fixed(@buf[0])^.data_offset);
  Current_Size:=Int64Swap(pVhd_Fixed(@buf[0])^.Current_Size);
  go:=true;
  mode:=3;
  end;
//
if (go=false) then //or (mode<>2) then
  begin
  writeln('file is not a vhd file and/or a fixed hard disk');
  closehandle(hDevice_src );
  exit;
  end;
{
if messageboxa(self.Handle ,pchar('create '+file_out+'?'),'CloneDisk',mb_yesno)=id_no then
  begin
  closehandle(hDevice_src );
  exit;
  end;
}
//****************************************************************
if mode=2 then
begin
total_size:=last-first;
{
if messageboxa(self.Handle ,pchar('Dump to '+file_out+'? '+inttostr(total_size div 1024 div 1024)+' Mb'),'CloneDisk',mb_yesno)=id_no then
  begin
  closehandle(hDevice_src );
  exit;
  end;
}
writeln('disk_type=fixed');
hDevice_dst := CreateFile(pchar(file_out), GENERIC_WRITE, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, CREATE_NEW, 0 , 0);
kBufferSize := 64* 1024  ;memsize:=kBufferSize;
buffer := VirtualAlloc(nil,kBufferSize,MEM_COMMIT or MEM_RESERVE, PAGE_READWRITE);
setfilepointer(hDevice_src ,int64rec(first).Lo ,@int64rec(first).hi,file_begin);
ipos:=0;
while (ipos<= last) and (CancelFlag=false) do
  begin
  if ipos+kBufferSize >total_size then kBufferSize :=total_size -ipos;
  ret:=ReadFile (hdevice_src, buffer^, kBufferSize, bytesread, nil);
  if (ret=false) then
     begin
     writeln('readfile error:'+SysErrorMessage(GetLastError));
     break;
     end;
  if bytesread=0 then break;
  ret:=WriteFile (hDevice_dst, buffer^, bytesread, byteswritten, nil);
  if (ret=false) or (bytesread<>byteswritten) then
     begin
     writeln('writefile error:'+SysErrorMessage(GetLastError));
     break;
     end;
  ipos:=ipos+kBufferSize;
  end;
VirtualFree(buffer,memsize, MEM_RELEASE);
closehandle(hDevice_dst );
//writeln('done converting fixed vhd to raw!');
end; //if mode=2
//*****************************************************
if mode=3 then
begin
//lets move to the dynamic header
SetFilePointer (hDevice_src, Data_Offset, nil, FILE_BEGIN );
fillchar(buf,512,0);
ReadFile (hDevice_Src, buf[0], 512, bytesread, nil);
if (pVhd_dyn(@buf[0])^.cookie ='cxsparse') then
  begin
  table_offset:=Int64Swap(pVhd_dyn(@buf[0])^.table_offset);
  block_size:=swap32(pVhd_dyn(@buf[0])^.block_size);
  max_entries:=swap32(pVhd_dyn(@buf[0])^.max_entries);
  {
  if messageboxa(self.Handle ,pchar('Dump to '+file_out+'? '+inttostr((block_size*max_entries) div 1024 div 1024)+' Mb'),'CloneDisk',mb_yesno)=id_no then
  begin
  closehandle(hDevice_src );
  exit;
  end;
  }
  writeln('disk_type=dynamic');
  //lets get the block allocation table
  //each dword points to a position in the vhd file
  //guest request sector 0 = index 0 in the bat = a position in the vhd
  SetFilePointer (hDevice_src, table_offset, nil, FILE_BEGIN );
  //list:=tstringlist.Create ;
  setlength(offsets,max_entries);
  //block_offset = sector offset (have to be multiplied by 512)
  for cnt:=0 to max_entries-1 do
    begin
    ret:=ReadFile (hDevice_Src, block_offset, 4, bytesread, nil);
    offsets[cnt]:=swap32(block_offset);
    //list.Add(inttostr(cnt)+'='+inttohex(swap32(block_offset)*512,4));
    end;
  //list.SaveToFile('c:\list.txt');
  //list.Free ;
  kBufferSize := block_size; memsize:=kbuffersize; //block_size;
  buffer := VirtualAlloc(nil,kBufferSize,MEM_COMMIT or MEM_RESERVE, PAGE_READWRITE);
  hDevice_dst := CreateFile(pchar(file_out), generic_read or GENERIC_WRITE, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, CREATE_NEW, 0 , 0);
  for cnt:=0 to max_entries-1 do
    begin
    if CancelFlag =true then break;
    if offsets[cnt]<$FFFFFE00 then   //4294966784=FFFFFE00 4294967295=FFFFFFFF
      begin
      ipos:=offsets[cnt]*512;
      if setfilepointer(hDevice_src ,int64rec(ipos).Lo ,@int64rec(ipos).hi,file_begin)=INVALID_SET_FILE_POINTER then
        begin
        writeln('writefile error:'+SysErrorMessage(GetLastError));
        break;
        end;
      //sectors bitmap 512 bytes * 8 bits = 4096 - By default, the size of a block is 4096 * 512-byte sectors = 2mb
      ret:=ReadFile (hDevice_Src, buf[0], 512, bytesread, nil);
      ipos:=ipos+512; //we just read one sector
      i:=0;j:=0;
      //for i:=0 to 511 do
      while i<512 do
        begin
        //Application.ProcessMessages ;
        bin:=DecToBinStr(buf[i]);
        while length(bin)<8 do bin:='0' + bin;
        for j:=0 to 7 do
          begin
          if bin[j+1]='1' then
          //if odd(buf[i] shr j) then
            begin
            setfilepointer(hDevice_src ,int64rec(ipos).Lo ,@int64rec(ipos).hi,file_begin);
            ret:=ReadFile (hDevice_Src, buffer^, 512, bytesread, nil);
            if (ret=false) then
             begin
             writeln('readfile error:'+SysErrorMessage(GetLastError));
             break;
             end;
            //if bytesread=0 then break;
            ret:=WriteFile (hDevice_dst, buffer^, bytesread, byteswritten, nil);
            if (ret=false) or (bytesread<>byteswritten) then
            begin
            writeln('writefile error:'+SysErrorMessage(GetLastError));
            break;
            end;
            end //if odd
            else ret:=WriteFile (hDevice_dst, empty[0], 512, byteswritten, nil);
          inc(ipos,512);
          end;//for j
        inc(i);
        end;//for i
      //2mb (block size) block data
      //ret:=ReadFile (hDevice_Src, buffer^, kBufferSize, bytesread, nil);
      //ret:=WriteFile (hDevice_dst, buffer^, bytesread, byteswritten, nil);
      end //if offsets[cnt]<>4294967295 then
      else
      begin
        fillchar(buffer^,kbuffersize,0);
        ret:=WriteFile (hDevice_dst, buffer^, kBufferSize, byteswritten, nil);;
      end;
    end;//for cnt:=0 to max_entries-1 do

  //expand the file size to what it should be?
  {
  ipos:=max_entries*block_size ;
  setfilepointer(hDevice_dst ,int64rec(ipos).Lo ,@int64rec(ipos).hi,file_begin);
  SetEndOfFile(hDevice_dst);
  }


  //
  closehandle(hDevice_dst );
  VirtualFree(buffer,memsize, MEM_RELEASE);
  end;//if (pVhd_dyn(@buf[0])^.cookie ='cxsparse') then
//writeln('done converting dynamic vhd to raw!');
end; //if mode=3
// ********************************************************
closehandle(hDevice_src );
end;

{
procedure resize2(file_in:string;new_size:int64);
var
file_out:string;
begin
file_out:=ChangeFileExt(file_in,'.img');
conv2img(file_in,file_out);
file_in:=file_out;
file_out:=file_in+'.vhd';
conv2fixvhd(file_in,file_out,new_size );
end;
}

begin

if paramcount=0 then
  begin
  writeln('vhd2img 0.2 by erwan.l@free.fr');
  writeln('vhd2img conv2img source_file.vhd dest_file.img');
  writeln('vhd2img conv2vhd source_file.img dest_file_fixed.vhd');
  writeln('vhd2img resize source_file_fixed.vhd size_in_Mbytes');
  writeln('vhd2img info source_file.vhd');
  end;

if paramstr(1)='conv2img' then
  begin
  writeln('creating new img file');
  conv2img(paramstr(2),paramstr(3));
  writeln('done');
  end;

if paramstr(1)='conv2vhd' then
  begin
  writeln('appending a 512bytes footer to the img file');
  conv2fixvhd(paramstr(2),paramstr(3));
  writeln('done');
  end;

if paramstr(1)='info' then
  begin
  info(paramstr(2));
  writeln('done');  
  end;

if paramstr(1)='resize' then
  begin           
  writeln('resizing vhd file to '+ paramstr(3));
  resize(paramstr(2),strtoint(paramstr(3))*1024*1024 );
  writeln('done');
  end;

end.
